c$Id:$
      subroutine umacr4(lct,ctl,prt)

c      * * F E A P * * A Finite Element Analysis Program

c....  Copyright (c) 1984-2004: Regents of the University of California
c                               All rights reserved

c-----[--.----+----.----+----.-----------------------------------------]
c      Purpose:   User interface for Watson Sparse Matrix Package solver

c      Reference: http://www.alphaworks.ibm.com/tech/wsmp

c      Inputs:
c         lct       - Command character parameters
c         ctl(3)    - Command numerical parameters
c         prt       - Flag, output if true

c      Outputs:
c         solver    - Indicates user solver or system solver
c                     .true.  = system solver
c                     .false. = user solver
c-----[--.----+----.----+----.-----------------------------------------]
      implicit  none

      include  'fdata.h'
      include  'iofile.h'
      include  'part0.h'
      include  'setups.h'
      include  'umac1.h'

      include  'wsmp_com.h'

      logical   pcomp,prt, setvar,palloc
      character lct*15,tname*5
      real*8    ctl(3)

      save

c     Install command WSMP (for Watson Sparse Matrix Package)

      if(pcomp(uct,'mac4',4)) then

        uct    = 'WSMP'
        write(*,2000) uct
        uct    = 'wsmp'
        wsmp_t = 0

c     Set solver type

      else

        if(pcomp(lct,'off',3)) then
          solver = .true.
          setvar = palloc(225,'USOL1', 0,1)
          setvar = palloc(226,'USOL2', 0,1)
          write(tname,'(4hTANG,i1)') npart
          setvar = palloc(npart,tname, 0,2)
          if(wsmp_t.ne.0) then
            write(*,*) ' TRY TO CLEAR!',wsmp_t
            call wsmpclear()
          endif
          wsmp_t = 0
        else
          solver = .false.
          if(pfr) then
            write(iow,2001)
            if(ior.lt.0) then
              write(*,2001)
            endif
          endif
        endif

      endif

2000  format(/' --> User solver ',a,' installed'/)
2001  format( '  WSMP Sparse Solver'/)

      end
